polls/urls.py
from django.urls import path

from . import views

app_name = 'polls'
urlpatterns = [
     # ex: /polls/
    path('', views.IndexView.as_view(), name='index'),
     # ex: /polls/5
    path('<int:pk>/', views.DetailView.as_view(), name='detail'),
    #ex: /polls/5/results
    path('<int:pk>/results/', views.ResultsView.as_view(), name='results'),
     #ex: /polls/5/vote
    path('<int:question_id>/vote/', views.vote, name='vote'),
]

tutodjango2/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('polls/', include('polls.urls')),
    path('admin/', admin.site.urls),
]

polls/models.py
import datetime

from django.db import models
from django.utils import timezone

class Question(models.Model):
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published')

    def __str__(self):
        return self.question_text

    def was_published_recently(self):
        now = timezone.now()
        return now - datetime.timedelta(days=1) <= self.pub_date <= now
    was_published_recently.admin_order_field = 'pub_date'
    was_published_recently.boolean = True
    was_published_recently.short_description = 'Published recently?'



class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self):
        return self.choice_text

polls/views.py
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from django.views import generic
from django.utils import timezone

from . models import Choice, Question

"""VERSION AVEC VUES GENERIQUES (ListView et DetailView)"""
class IndexView(generic.ListView):
    #utiliser template_name pour redéfinir le template (nom du gabarit)
    template_name = 'polls/index.html'
    context_object_name = 'latest_question_list'

    def get_queryset(self):
        """Retourne les cinq dernières questions"""
        return Question.objects.filter(pub_date__lte=timezone.now()).order_by('-pub_date')[:5]

class DetailView(generic.DetailView):
    model = Question
    template_name = 'polls/detail.html'

    def get_queryset(self):
        return Question.objects.filter(pub_date__lte=timezone.now())

class ResultsView(generic.DetailView):
    model = Question
    template_name = 'polls/results.html'

def vote(request, question_id):
    question = get_object_or_404(Question, pk=question_id)
    try:
        selected_choice = question.choice_set.get(pk=request.POST['choice'])
    except (KeyError, Choice.DoesNotExist):
        # Si erreur, reproposer à l'utilisateur de voter
        return render(request, 'polls/detail.html', {
            'question': question,
            'error_message': "You didn't select a choice.",
        })
    else:
        selected_choice.votes += 1
        selected_choice.save()
        # Toujours retourner avec HttpResponseRedirect
        # après la soumission d'un formulaire POST
        return HttpResponseRedirect(reverse('polls:results', args=(question.id,)))
    

polls/templates/polls/detail.html
<h1>{{ question.question_text }}</h1>

{% if error_message %}
<p><strong>{{ error_message }}</strong></p>
{% endif %}

<form action="{% url 'polls:vote' question.id %}" method="post">
{% csrf_token %}
{% for choice in question.choice_set.all %}
    <input type="radio" name="choice" id="choice{{ forloop.counter }}" value="{{ choice.id }}">
    <label for="choice{{ forloop.counter }}">{{ choice.choice_text }}</label><br>
{% endfor %}
<input type="submit" value="Vote">
</form>

polls/templates/polls/index.html
<!DOCTYPE html>
<html lang="en">

<head>
    {% load static %}
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" type="text/css" href="{% static 'polls/style.css' %}">
    <title>Tuto Django</title>
</head>

<body>
    <div class="container">
        <header>
            <div>
                <a href="{% url 'polls:index' %}"><img class="logo" src="{% static "polls/images/django.png" %}"></a>
            </div>
        </header>
        {% include "admin/base_site.html" %}
        {% if latest_question_list %}
        <ul>
            {% for question in latest_question_list %}
            <li>Question {{question.id}} :
                <a href="{% url 'polls:detail' question.id %}">
                    {{ question.question_text }}
            </a> 
            -- Date de publication : {{question.pub_date}}
            </li>
            {% endfor %}
        </ul>
        {% else %}
        <p>No polls are available.</p>
        {% endif %}
    </div>
</body>

</html>

polls/templates/polls/results.html
<h1>{{ question.question_text }}</h1>

<ul>
{% for choice in question.choice_set.all %}
    <li>{{ choice.choice_text }} 
        -- {{ choice.votes }} vote{{ choice.votes|pluralize }}</li>
{% endfor %}
</ul>

<a href="{% url 'polls:detail' question.id %}">Vote again?</a>